Make WordPress Core


Ignore:
Timestamp:
03/11/2025 02:17:41 PM (12 months ago)
Author:
TimothyBlynJacobs
Message:

REST API: Fix fatal error when making HEAD requests with _fields filter.

In [59889] the REST API controllers were adjusted to perform less work when responding to HEAD requests. The WP_REST_Response body would now be null, which caused issues with filters that expected the response body to be an array.

This commit sets the response body to be an empty array when preparing the response instead. The body will still be discarded, but this provides better backward comppatibility with code that assumes an array will be used.

See #56481.
Props antonvlasenko, timothyblynjacobs, mamaduka, wildworks.

File:
1 edited

Legend:

Unmodified
Added
Removed
  • trunk/src/wp-includes/rest-api/endpoints/class-wp-rest-comments-controller.php

    r59899 r59970  
    314314        }
    315315
    316         $response = $is_head_request ? new WP_REST_Response() : rest_ensure_response( $comments );
     316        $response = $is_head_request ? new WP_REST_Response( array() ) : rest_ensure_response( $comments );
    317317        $response->header( 'X-WP-Total', $total_comments );
    318318        $response->header( 'X-WP-TotalPages', $max_pages );
     
    10551055        if ( $request->is_method( 'HEAD' ) ) {
    10561056            /** This filter is documented in wp-includes/rest-api/endpoints/class-wp-rest-comments-controller.php */
    1057             return apply_filters( 'rest_prepare_comment', new WP_REST_Response(), $comment, $request );
     1057            return apply_filters( 'rest_prepare_comment', new WP_REST_Response( array() ), $comment, $request );
    10581058        }
    10591059
Note: See TracChangeset for help on using the changeset viewer.